package fortyonepost.com.cis; // 41 Post - Created by DimasTheDriver on June/28/2012 . Part of the 'Android - Changing Image Color Saturation' post. Available at: http://www.41post.com/?p=4837.

import android.os.Bundle;
import android.widget.ImageView;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.ColorMatrix;
import android.graphics.ColorMatrixColorFilter;
import android.graphics.Paint;

public class CISactivity extends Activity 
{
	//An ImageView and a SeekBar
	private ImageView ivImage;
	private SeekBar sbSeekBar;
	
	//These member variables responsible for modifying the color saturation
	private ColorMatrix colorMatrix;
	private ColorMatrixColorFilter cmFilter;
	private Paint cmPaint;
	
	//These member variables are responsible for drawing the Bitmap
	private Canvas cv;
	private Bitmap imgBitmap;
	private Bitmap canvasBitmap;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cisactivity);
        
        //Initialize the ColorMatrix object
        colorMatrix = new ColorMatrix();
        //Initialize the ColorMatrixColorFilter object
		cmFilter = new ColorMatrixColorFilter(this.colorMatrix);
		
		//Initialize the cmPaint
		cmPaint = new Paint();
		//Set 'cmFilter' as the color filter of this paint
		cmPaint.setColorFilter(cmFilter);
        
		//Initialize the 'imgBitmap' by decoding the 'exampleimage.png' file
		imgBitmap = BitmapFactory.decodeResource(getResources(), R.drawable.exampleimage);
		//Create a new mutable Bitmap, with the same width and height as the 'imgBitmap'
		canvasBitmap = Bitmap.createBitmap(128, 128, Bitmap.Config.ARGB_8888);
		//Initialize the canvas assigning the mutable Bitmap to it
		cv = new Canvas(canvasBitmap);
        
		//Initialize the ImageView and the SeekBar objects by inflating them 'activity_cisactivity.xml' layout file
        ivImage = (ImageView) findViewById(R.id.iv_exampleimage);
        sbSeekBar = (SeekBar) findViewById(R.id.sb_seekbar);
        
        //Sets the range between 0 and 100
        sbSeekBar.setMax(100);
        //Set the seek bar increments to 1
        sbSeekBar.setKeyProgressIncrement(1);
        //Set the progress to 100
        sbSeekBar.setProgress(100);
        
        sbSeekBar.setOnSeekBarChangeListener(new OnSeekBarChangeListener() 
		{
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) 
			{
			}
			
			@Override
			public void onStartTrackingTouch(SeekBar seekBar) 
			{
			}
			
			//This method is called every time the SeekBar thumb is dragged
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) 
			{
				//Set the ColorMatrix saturation according to the SeekBar progress
				colorMatrix.setSaturation(progress/(float)100);
				//Create a new ColorMatrixColorFilter with the recently altered colorMatrix
				cmFilter = new ColorMatrixColorFilter(colorMatrix);
				
				//Assign the ColorMatrix to the paint object again
				cmPaint.setColorFilter(cmFilter);
				
				//Draw the Bitmap into the mutable Bitmap using the canvas. Don't forget to pass the Paint as the last parameter
				cv.drawBitmap(imgBitmap, 0, 0, cmPaint);
				//Set the mutable Bitmap to be rendered by the ImageView
				ivImage.setImageBitmap(canvasBitmap);				
			}
		});	
    }
}
